#include <stdio.h>
#include <stdlib.h>

#include "bmsg.h"

int main (int argc, char **argv)
{
  int t, i, limit, n, v;
  struct connection_t **c;
  int *working;

  t = (argc - 2) / 2;

  c = (struct connection_t **)malloc(t * sizeof(struct connection_t *));
  working = (int *)malloc(t * sizeof(int));

  /* Connect to all servers: */
  for (i = 0; i < t; i++) {
    c[i] = make_connection(argv[(i * 2) + 2], argv[(i * 2) + 3]);
    send_byte_message(c[i], sizeof(i), &i); /* send id */
    working[i] = -1; /* initially idle */
  }

  limit = atoi(argv[1]);

  n = 0;
  while (n < limit) {
    /* push work out to idle servers: */
    for (i = 0; i < t; i++) {
      if (working[i] == -1) {
        send_byte_message(c[i], sizeof(n), &n);
        n++;
        working[i] = n;
      }
    }

    i = wait_connection_recv(t, c);
    recv_byte_message(c[i], sizeof(v), &v);

    printf("client from %d: %d => %d\n", i, working[i], v);
    working[i] = -1;
  }
  /* all work has been sent out */

  for (i = 0; i < t; i++) {
    if (working[i] != -1) {
      /* wait until done: */
      recv_byte_message(c[i], sizeof(v), &v);
    }
    /* tell server we're done: */
    n = -1;
    send_byte_message(c[i], sizeof(n), &n);
    close_connection(c[i]);
  }

  return 0;
}
